%General code for plotting 2D PDF
%Tianze Peng and David Richter
%for the JPO paper: https://journals.ametsoc.org/doi/abs/10.1175/JPO-D-18-0193.1
format long
% change below to corresponding cases accordingly
r_dis=25;%unit [um]
ph_dis=1;%unit [%]
T_init=298.15;r_init=r_dis*1e-6;
Re=300;
pathname='[Path]';
ihisstart=0105001;itape=5000;ihisend=0250001;
groupname='M1',casename='r025ph10' %group name and case name
nbins = 512; 
% setting figure axes, change as needed
JntPDFname='tdTp'
histog2Dname = 'dT vs t_L';
Xlabel='dT';Ylabel='t_L';
var1name='\Delta T_p';unit1=' [\mum]';var2name='t_L';unit2=' [m]';
figid = zeros(1,length(histog2Dname));
hst2D=zeros(nbins+2,nbins+2);ns=0; 
for it = ihisstart:itape:ihisend-itape
ns=ns+1;
PDFMAT=load([pathname,groupname,'/',casename,...
    '/',JntPDFname,'.le.cou.',num2str(it,'%07i'),'_',num2str(it+itape,'%07i'),'.txt']);
hst2D=PDFMAT(2:end,2:end)+hst2D; %1)
end
%%
xscale=1;yscale=1;
Var1label=[var1name,unit1];Var2label=[var2name,unit2];

var1=PDFMAT(1,2:end)/xscale;var2=PDFMAT(2:end,1)/yscale;
[Var1 Var2]=meshgrid(var1,var2); %axis
dxT=var1(2)-var1(1);dyT=var2(2)-var2(1);
NdThst=sum(sum(hst2D));pdf2D=hst2D/NdThst/dxT/dyT;
%setting xlim and ylim auto
Txlim='auto';tLlim='auto';

Hy=trapz(var1,pdf2D)*dyT/dxT;   %dTp
Hx=trapz(var2,pdf2D,2)*dxT/dyT; %tL
Xdata=[var2';var1]';
Ydata=[Hx';Hy]';

log_pdf2D=log(pdf2D);
log_pdf2D((~isfinite(log_pdf2D)))=NaN;
histogname = {'Ystats','Xstats'};hist =zeros(length(histogname),1);
meanval = cell(length(histogname),2);
meanval(:,1) = {'E(Ystats): ','E(Xstats): '};
for i=1:length(histogname),meanval(i,2)={trapz(Xdata(:,i),Xdata(:,i).*Ydata(:,i))};end
meanval

fig1=figure(101);
contourf(Var1,Var2,log_pdf2D)
ylim(tLlim);
xlim(Txlim)
xlabel(Xlabel),ylabel(Ylabel),title(['Re=',num2str(Re),', r_p=',num2str(r_dis),'\mum'])
shading interp
colormap(cool);caxis auto;%([cmin cmaxT]);

%% marginal mean
mean2v1=zeros(1,length(var2));for iz=1:1:length(var2);
    mean2v1(iz)=trapz(var1,var1.*pdf2D(iz,:))/trapz(var1,pdf2D(iz,:));end
mean1v2=zeros(1,length(var1));for iz=1:1:length(var1);
    mean1v2(iz)=trapz(var2,pdf2D(:,iz).*var2)/trapz(var2,pdf2D(:,iz));end
figure(111)
hold on
plot(var2,mean2v1)
xlabel(Var2label),ylabel(['E(',var1name,')@',var2name,unit1])
title(['mean ',var1name,' given ',var2name])
figure(112)
hold on
plot(var1,mean1v2)
xlabel(Var1label),ylabel(['E(',var2name,')@',var1name,unit2])
title(['mean ',var2name,' given ',var1name])